#!/usr/bin/env python3
""" Assignment 5: German compound splitting as sequence labeling
    See <https://snlp2019.github.io/a5/> for instructions.

    **Please insert your name(s), and the names of people or links to the
    resources that you got help for your solution.**

"""

import argparse
import numpy as np


def read_data(filename, pad=True, max_len=None, bos='<', eos='>'):
    """ Exercise 1(a): read a data file.

    Read the data file, and return two sequences words and labels.
    The "words" returned should not have any spaces,
    labels should be strings similar to words composed of characters
    'B', 'I', or 'O'. Indicating beginning of a word, inside a word,
    and a non-word character respectively. 

    Always append a beginning-of-sequence character (can be disabled
    by setting bos='').
    
    If the argument pad=True (always in this assignment) you should
    make sure that words returned are padded with the "eos" character 
    to make sure that the length is max_len + 1 (+1 for the 'bos').
    If max_len is not given, it should be set to length of the longest
    word in the data. The words longer than max_len should be
    truncated.
    """
    pass

class InputOutputEncoder:
    """ Exercise 1(b): A class to encode/decode characters and labels.
    """
    def __init__(self):
        pass

    def fit(self, words, labels):
        pass

    def transform(self, words, labels):
        pass

    def fit_transform(self, words, labels):
        self.fit(words, labels)
        return self.transform(words, labels)

    def inv_labels(self, encoded_labels):
        """ Return symbolic labels for the given sequence of encoded labels.
        """
        pass

def train_rnn(x, y, rnn_type='GRU', hidden_dim=10, optimizer='adam'):
    """ Exercise 2: Train and return a Keras RNN mode.

    Arguments:
    rnn_type        Type of RNN cell to use  
    hidden_dim      The hidden dimension of RNN cell
    optimizer       The optimization algorithm
    """
    pass

def segment(words, labels, strip=True):
    """ Exercise 3: Segment given words based on character labels.

    Given unsegmented words and their labels, return a list of
    segmented words. If the argument "strip" is true, remove all
    beginning- and end-of-sequence symbols.
    """
    pass

def evaluate(gold_labels, pred_labels):
    """ Exercise 4: Return the evaluation scores.
    """
    pass


if __name__ == '__main__':
    # Example use of the implementation,
    # you are free to change it

    argp = argparse.ArgumentParser()
    argp.add_argument('command', choices=('segment', 'score'))
    argp.add_argument('train')
    argp.add_argument('test')
    args = argp.parse_args()

    words, labels = read_data(args.train)
    enc = InputOutputEncoder()
    x_train, y_train = enc.fit_transform(words, labels)

    words, labels = read_data(args.test[2], max_len=x_train.shape[1]-1)
    x_test, y_test = enc.transform(words, labels)
    m = train_rnn(x_train, y_train)

    y_pred = m.predict(x_test)
    pred_labels = enc.inv_labels(y_pred)

    if command == 'segment':
        for w in segment(words, pred_labels):
            print(w)
    elif command == 'score':
        print(evaluate(labels, pred_labels))
